## mypy 1.19.1

=== debian/changelog ===
mypy (1.19.1-4) unstable; urgency=medium

  * python3-orjson is also available on i386.
  * Depend on newer dh-python and remove our parallel-building hack, now
    that it implements parallel building for us.

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 03 Mar 2026 10:25:48 +0100

mypy (1.19.1-3) unstable; urgency=medium

  * Added patch for compatibility with pathspec version 1.0.0+

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 24 Feb 2026 11:15:16 +0100

mypy (1.19.1-2) unstable; urgency=medium

  * d/tests: depend on all python3 -dev packages, not just the default
    version.

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 16 Dec 2025 15:29:18 +0100

mypy (1.19.1-1) unstable; urgency=medium

  * d/rules: cope with no "parallel" setting in DEB_BUILD_OPTIONS
  * New upstream version
  * debputy lint --auto-fix (routine-update)
  * d/control: hard-code binary dependency on librt
  * d/rules: adjust test invocation
  * Self-test: assume Python 3.10 due to newer pytest version.

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 16 Dec 2025 15:03:11 +0100
